package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.meta.TypeMeta;

public class AlignmentConstructorGen extends ViewClassConstructorGen {



	public AlignmentConstructorGen(ClassGen classgen, TypeMeta type) {
		super(classgen, "public", "", classgen.getClassName(), new VariableGen(short.class, "alignment"));
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		pout.append("super(").append(parameters[0].getName()).println(");");
	}
	
	

}
