package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;

public class CopyConstructorGen extends ViewClassConstructorGen {

	public CopyConstructorGen(ClassGen classgen) {
		super(classgen, "public", "", classgen.getClassName(), new VariableGen(classgen.getClassName(), "that"));
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		

		pout.append("super(");
		pout.indent(+1);
		for (int i = 0; i < parameters.length; i++) {
			pout.append(parameters[i].getName());
			if (i+1 < parameters.length) {
				pout.append(", ");
			}
		}
		pout.indent(-1);
		pout.println(");");
		
	}
	

}
