package org.cakelab.nio.generator.codegen.struct;

import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.StaticInitBlock;
import org.cakelab.nio.common.Global;

public class StaticVersionCheck extends StaticInitBlock {

	@Override
	protected void writeBlockContent(IndentStreamControl pout) {
		String testAttribute = Global.class.getCanonicalName() + "." + Global.VERSION_TEST_FIELD;
		pout.println("/* If the following statement causes a compile error, the generated ");
		pout.println(" * class is not compatible with the given version of org.cakelab.nio. */");
		pout.println("assert " + testAttribute + ";");
	}

}
