package org.cakelab.nio.generator.codegen.struct;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.codegen.VariableGen;
import org.cakelab.nio.generator.codegen.Utils;
import org.cakelab.nio.meta.FieldMeta;

public class StructFieldSetterMethodGen extends StructFieldMethodGen {

	public StructFieldSetterMethodGen(ClassGen classgen, FieldMeta fieldMeta) {
		super(classgen, fieldMeta, void.class, "set" + Utils.toCamelCase(fieldMeta.name), new VariableGen(fieldMeta.getType(), fieldMeta.name));
	}
	
	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {

		pout.println("this." + fieldMeta.name + ".set(" + parameters[0].getName() + ");");
	}



}
