package org.cakelab.nio.view.impl;

import org.cakelab.nio.view.GenericDataView;

/**
 * Base class of all struct views, either generated or implemented 
 * by the application programmer.
 * 
 * @author homac
 *
 * @param <T>
 */
public abstract class StructViewBase<T> extends DataViewBase implements GenericDataView<T> {

	public StructViewBase(StructViewBase<T> that) {
		super(that);
	}

	public StructViewBase(short alignment) {
		super(alignment);
	}
}
