package test;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;

import org.cakelab.nio.Init;

public class Main {

	public static void main(String[] args) throws IOException, ClassNotFoundException, NoSuchMethodException, SecurityException, IllegalAccessException, IllegalArgumentException, InvocationTargetException, InstantiationException {
		System.setProperty("joml.debug", "true");
		Init.debug(true);
		
		test.simple.TestBase.test();
		test.struct.Test.test();
		test.array.scalar.TestBase.test();
		test.array.complex.TestBase.test();
		test.array.view.TestArrayView.test();
		test.strings.TestBase.test();
		test.bool.TestMyBoolStruct.test();
	}

}
