package test.array.scalar;

import java.util.Arrays;

import test.TestRandomizer;

public class TestBase {
	protected static TestRandomizer rng = new TestRandomizer();


	public static void test() {
		for (int i = 0; i < 4; i++) {
			TestMyArrayStruct.test((short)(1<<i));
		}
		
		for (int i = 0; i < 4; i++) {
			TestMyArrayStructAligned.test((short)(1<<i));
		}
	}
	
	public static boolean equals(int[] a1, int[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(byte[] a1, byte[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(double[] a1, double[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(float[] a1, float[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(char[] a1, char[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(short[] a1, short[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(long[][][] a1, long[][][] a2) {
		return Arrays.deepEquals(a1, a2);
	}

	public static boolean equals(long[][] a1, long[][] a2) {
		return Arrays.deepEquals(a1,a2);
	}

	public static boolean equals(long[] a1, long[] a2) {
		return Arrays.equals(a1,a2);
	}

	public static boolean equals(int[][] a1, int[][] a2) {
		return Arrays.deepEquals(a1,a2);
	}

}
