package test.generator;

import java.io.File;
import java.io.IOException;

import org.cakelab.nio.generator.Generator;

import test.array.complex.MyStructArray;
import test.array.complex.MyStructArrayAligned;
import test.array.scalar.MyArrayStruct;
import test.array.scalar.MyArrayStructAligned;
import test.bool.MyBoolStruct;
import test.bool.MyBoolStructAligned;
import test.simple.MySimpleStruct;
import test.simple.MySimpleStructAligned;
import test.strings.MyStringStruct;
import test.strings.MyStringStructAligned;
import test.struct.MyStructStruct;
import test.struct.MyStructStructAligned;

public class Test {

	public static class MyStruct{}
	
	public static void main(String[] args) throws IOException {
		test();
	}
	
	
	public static void test() throws IOException {
		@SuppressWarnings("resource")
		Generator generator = new Generator(new File("tmp"), true, true, false);

		generator.generate(MySimpleStruct.class);
		generator.generate(MySimpleStructAligned.class);
		generator.generate(MyArrayStruct.class);
		generator.generate(MyArrayStructAligned.class);
		generator.generate(MyStructArray.class);
		generator.generate(MyStructArrayAligned.class);
		generator.generate(MyBoolStruct.class);
		generator.generate(MyBoolStructAligned.class);
		generator.generate(MyStringStruct.class);
		generator.generate(MyStringStructAligned.class);
		generator.generate(MyStructStruct.class);
		generator.generate(MyStructStructAligned.class);

	}

}
