package org.cakelab.nio.view.generated.test.array.scalar;


import org.cakelab.nio.view.array.floatArrayView;
import org.cakelab.nio.view.array.intArrayView;
import org.cakelab.nio.view.array.doubleArrayView;
import org.cakelab.nio.view.array.byteArrayView;
import org.cakelab.nio.view.array.longArrayView;
import org.cakelab.nio.view.array.shortArrayView;
import org.cakelab.nio.view.ReusableDataView;
import org.cakelab.nio.view.impl.StructViewBase;
import org.cakelab.nio.view.array.charArrayView;
import org.cakelab.nio.view.array.CArrayView;


/**
 * Generated view class for {@link test.array.scalar.MyArrayStruct}
 */
public class MyArrayStructView extends StructViewBase<test.array.scalar.MyArrayStruct> implements ReusableDataView<test.array.scalar.MyArrayStruct> {
    static {
        /* If the following statement causes a compile error, the generated 
         * class is not compatible with the given version of org.cakelab.nio. */
        assert org.cakelab.nio.common.Global.VERSION_COMPATIBLE_1_0;
    }
    private test.array.scalar.myByteView _byte_array_user = new test.array.scalar.myByteView((short)1);
    
    public  MyArrayStructView()
    {
        super((short)1);
    }
    
    public  MyArrayStructView(MyArrayStructView that)
    {
        super(that);
    }
    
    public  MyArrayStructView(short alignment)
    {
        super(alignment);
    }
    
    public test.array.scalar.MyArrayStruct get()
    {
        return get(this.newDataInstance());
    }
    
    public test.array.scalar.MyArrayStruct get(test.array.scalar.MyArrayStruct result)
    {
        get_byte_array(result._byte_array);
        get_byte_array_user(result._byte_array_user);
        get_short_array(result._short_array);
        get_int_array_array(result._int_array_array);
        get_long_array_array_array(result._long_array_array_array);
        get_char_array(result._char_array);
        get_float_array(result._float_array);
        getDouble_array(result.Double_array);
        return result;
    }
    
    public void set(test.array.scalar.MyArrayStruct value)
    {
        set_byte_array(value._byte_array);
        set_byte_array_user(value._byte_array_user);
        set_short_array(value._short_array);
        set_int_array_array(value._int_array_array);
        set_long_array_array_array(value._long_array_array_array);
        set_char_array(value._char_array);
        set_float_array(value._float_array);
        setDouble_array(value.Double_array);
    }
    
    public byte get_byte_array(int index0)
    {
        byte result;
        int __nio__member_offset = 0;
        /* calc indexed offset */
        __nio__member_offset += (index0*1);
        result = __nio__buffer.get(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public byte[] get_byte_array()
    {
        return get_byte_array(new byte[1]);
    }
    
    public byte[] get_byte_array(byte[] value)
    {
        assert(
            value != null
            && value.length == 1
        );
        int __nio__member_offset = 0;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        __nio__buffer.get(value);
        return value;
    }
    
    public void set_byte_array(byte value, int index0)
    {
        int __nio__member_offset = 0;
        /* calc indexed offset */
        __nio__member_offset += (index0*1);
        __nio__buffer.put(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_byte_array(byte[] value)
    {
        assert(
            value != null
            && value.length == 1
        );
        int __nio__member_offset = 0;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        __nio__buffer.put(value);
    }
    
    public byteArrayView view_byte_array()
    {
        byteArrayView view = byteArrayView.create(1);
        view.open(__nio__buffer, 0);
        return view_byte_array(view);
    }
    
    public byteArrayView view_byte_array(byteArrayView view)
    {
        int __nio__member_offset = __nio__offset + 0;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public byte get_byte_array_user(int index0)
    {
        byte result;
        int __nio__stride = 1;
        int __nio__elem__offset = __nio__offset + 1;
        __nio__elem__offset += (index0*1);
        this._byte_array_user.offset(__nio__elem__offset);
        result = this._byte_array_user.get();
        __nio__elem__offset += __nio__stride;
        return result;
    }
    
    public byte[] get_byte_array_user()
    {
        return get_byte_array_user(new byte[8]);
    }
    
    public byte[] get_byte_array_user(byte[] value)
    {
        assert(
            value != null
            && value.length == 8
        );
        int __nio__stride = 1;
        int __nio__elem__offset = __nio__offset + 1;
        for (int index0 = 0; index0 < 8; index0++) {
            this._byte_array_user.offset(__nio__elem__offset);
            value[index0] = this._byte_array_user.get();
            __nio__elem__offset += __nio__stride;
        }
        return value;
    }
    
    public void set_byte_array_user(byte value, int index0)
    {
        int __nio__stride = 1;
        int __nio__elem__offset = __nio__offset + 1;
        __nio__elem__offset += (index0*1);
        this._byte_array_user.offset(__nio__elem__offset);
        this._byte_array_user.set(value);
        __nio__elem__offset += __nio__stride;
    }
    
    public void set_byte_array_user(byte[] value)
    {
        assert(
            value != null
            && value.length == 8
        );
        int __nio__stride = 1;
        int __nio__elem__offset = __nio__offset + 1;
        for (int index0 = 0; index0 < 8; index0++) {
            this._byte_array_user.offset(__nio__elem__offset);
            this._byte_array_user.set(value[index0]);
            __nio__elem__offset += __nio__stride;
        }
    }
    
    public byteArrayView view_byte_array_user()
    {
        byteArrayView view = byteArrayView.create(new test.array.scalar.myByteView((short)1), 8);
        view.open(__nio__buffer, 0);
        return view_byte_array_user(view);
    }
    
    public byteArrayView view_byte_array_user(byteArrayView view)
    {
        int __nio__member_offset = __nio__offset + 1;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public test.array.scalar.myByteView view_byte_array_user(int index0)
    {
        test.array.scalar.myByteView view = new test.array.scalar.myByteView((short)1);
        view.open(__nio__buffer, 0);
        return view_byte_array_user(view, index0);
    }
    
    public test.array.scalar.myByteView view_byte_array_user(test.array.scalar.myByteView view, int index0)
    {
        int __nio__member_offset = __nio__offset + 1;
        /* calc indexed offset */
        __nio__member_offset += (index0*1);
        view.offset(__nio__member_offset);
        return view;
    }
    
    public short get_short_array(int index0)
    {
        short result;
        int __nio__member_offset = 9;
        /* calc indexed offset */
        __nio__member_offset += (index0*2);
        result = __nio__buffer.getShort(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public short[] get_short_array()
    {
        return get_short_array(new short[2]);
    }
    
    public short[] get_short_array(short[] value)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__member_offset = 9;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.ShortBuffer tmpBuffer = __nio__buffer.asShortBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public void set_short_array(short value, int index0)
    {
        int __nio__member_offset = 9;
        /* calc indexed offset */
        __nio__member_offset += (index0*2);
        __nio__buffer.putShort(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_short_array(short[] value)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__member_offset = 9;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.ShortBuffer tmpBuffer = __nio__buffer.asShortBuffer();
        tmpBuffer.put(value);
    }
    
    public shortArrayView view_short_array()
    {
        shortArrayView view = shortArrayView.create(2);
        view.open(__nio__buffer, 0);
        return view_short_array(view);
    }
    
    public shortArrayView view_short_array(shortArrayView view)
    {
        int __nio__member_offset = __nio__offset + 9;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public int get_int_array_array(int index0, int index1)
    {
        int result;
        int __nio__member_offset = 13;
        /* calc indexed offset */
        __nio__member_offset += (index0*32 + index1*4);
        result = __nio__buffer.getInt(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public int[] get_int_array_array(int index0)
    {
        return get_int_array_array(new int[8], index0);
    }
    
    public int[] get_int_array_array(int[] value, int index0)
    {
        assert(
            value != null
            && value.length == 8
        );
        int __nio__member_offset = 13;
        /* calc indexed offset */
        __nio__member_offset += (index0*32);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.IntBuffer tmpBuffer = __nio__buffer.asIntBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public int[][] get_int_array_array()
    {
        return get_int_array_array(new int[2][8]);
    }
    
    public int[][] get_int_array_array(int[][] value)
    {
        assert(
            value != null
            && value.length == 2
            && value[0].length == 8
        );
        int __nio__member_offset = 13;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.IntBuffer tmpBuffer = __nio__buffer.asIntBuffer();
        for (int index0 = 0; index0 < 2; index0++) {
            tmpBuffer.get(value[index0]);
        }
        return value;
    }
    
    public void set_int_array_array(int value, int index0, int index1)
    {
        int __nio__member_offset = 13;
        /* calc indexed offset */
        __nio__member_offset += (index0*32 + index1*4);
        __nio__buffer.putInt(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_int_array_array(int[] value, int index0)
    {
        assert(
            value != null
            && value.length == 8
        );
        int __nio__member_offset = 13;
        /* calc indexed offset */
        __nio__member_offset += (index0*32);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.IntBuffer tmpBuffer = __nio__buffer.asIntBuffer();
        tmpBuffer.put(value);
    }
    
    public void set_int_array_array(int[][] value)
    {
        assert(
            value != null
            && value.length == 2
            && value[0].length == 8
        );
        int __nio__member_offset = 13;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.IntBuffer tmpBuffer = __nio__buffer.asIntBuffer();
        for (int index0 = 0; index0 < 2; index0++) {
            tmpBuffer.put(value[index0]);
        }
    }
    
    public CArrayView<int[],intArrayView> view_int_array_array()
    {
        CArrayView<int[],intArrayView> view = new CArrayView<int[],intArrayView>(intArrayView.create(8), 2);
        view.open(__nio__buffer, 0);
        return view_int_array_array(view);
    }
    
    public CArrayView<int[],intArrayView> view_int_array_array(CArrayView<int[],intArrayView> view)
    {
        int __nio__member_offset = __nio__offset + 13;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public long get_long_array_array_array(int index0, int index1, int index2)
    {
        long result;
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48 + index1*16 + index2*8);
        result = __nio__buffer.getLong(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public long[] get_long_array_array_array(int index0, int index1)
    {
        return get_long_array_array_array(new long[2], index0, index1);
    }
    
    public long[] get_long_array_array_array(long[] value, int index0, int index1)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48 + index1*16);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public long[][] get_long_array_array_array(int index0)
    {
        return get_long_array_array_array(new long[3][2], index0);
    }
    
    public long[][] get_long_array_array_array(long[][] value, int index0)
    {
        assert(
            value != null
            && value.length == 3
            && value[0].length == 2
        );
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        for (int index1 = 0; index1 < 3; index1++) {
            tmpBuffer.get(value[index1]);
        }
        return value;
    }
    
    public long[][][] get_long_array_array_array()
    {
        return get_long_array_array_array(new long[4][3][2]);
    }
    
    public long[][][] get_long_array_array_array(long[][][] value)
    {
        assert(
            value != null
            && value.length == 4
            && value[0].length == 3
            && value[0][0].length == 2
        );
        int __nio__member_offset = 77;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        for (int index0 = 0; index0 < 4; index0++) {
            for (int index1 = 0; index1 < 3; index1++) {
                tmpBuffer.get(value[index0][index1]);
            }
        }
        return value;
    }
    
    public void set_long_array_array_array(long value, int index0, int index1, int index2)
    {
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48 + index1*16 + index2*8);
        __nio__buffer.putLong(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_long_array_array_array(long[] value, int index0, int index1)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48 + index1*16);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        tmpBuffer.put(value);
    }
    
    public void set_long_array_array_array(long[][] value, int index0)
    {
        assert(
            value != null
            && value.length == 3
            && value[0].length == 2
        );
        int __nio__member_offset = 77;
        /* calc indexed offset */
        __nio__member_offset += (index0*48);
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        for (int index1 = 0; index1 < 3; index1++) {
            tmpBuffer.put(value[index1]);
        }
    }
    
    public void set_long_array_array_array(long[][][] value)
    {
        assert(
            value != null
            && value.length == 4
            && value[0].length == 3
            && value[0][0].length == 2
        );
        int __nio__member_offset = 77;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.LongBuffer tmpBuffer = __nio__buffer.asLongBuffer();
        for (int index0 = 0; index0 < 4; index0++) {
            for (int index1 = 0; index1 < 3; index1++) {
                tmpBuffer.put(value[index0][index1]);
            }
        }
    }
    
    public CArrayView<long[][],CArrayView<long[],longArrayView>> view_long_array_array_array()
    {
        CArrayView<long[][],CArrayView<long[],longArrayView>> view = new CArrayView<long[][],CArrayView<long[],longArrayView>>(new CArrayView<long[],longArrayView>(longArrayView.create(2), 3), 4);
        view.open(__nio__buffer, 0);
        return view_long_array_array_array(view);
    }
    
    public CArrayView<long[][],CArrayView<long[],longArrayView>> view_long_array_array_array(CArrayView<long[][],CArrayView<long[],longArrayView>> view)
    {
        int __nio__member_offset = __nio__offset + 77;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public char get_char_array(int index0)
    {
        char result;
        int __nio__member_offset = 269;
        /* calc indexed offset */
        __nio__member_offset += (index0*2);
        result = __nio__buffer.getChar(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public char[] get_char_array()
    {
        return get_char_array(new char[3]);
    }
    
    public char[] get_char_array(char[] value)
    {
        assert(
            value != null
            && value.length == 3
        );
        int __nio__member_offset = 269;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.CharBuffer tmpBuffer = __nio__buffer.asCharBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public void set_char_array(char value, int index0)
    {
        int __nio__member_offset = 269;
        /* calc indexed offset */
        __nio__member_offset += (index0*2);
        __nio__buffer.putChar(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_char_array(char[] value)
    {
        assert(
            value != null
            && value.length == 3
        );
        int __nio__member_offset = 269;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.CharBuffer tmpBuffer = __nio__buffer.asCharBuffer();
        tmpBuffer.put(value);
    }
    
    public charArrayView view_char_array()
    {
        charArrayView view = charArrayView.create(3);
        view.open(__nio__buffer, 0);
        return view_char_array(view);
    }
    
    public charArrayView view_char_array(charArrayView view)
    {
        int __nio__member_offset = __nio__offset + 269;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public float get_float_array(int index0)
    {
        float result;
        int __nio__member_offset = 275;
        /* calc indexed offset */
        __nio__member_offset += (index0*4);
        result = __nio__buffer.getFloat(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public float[] get_float_array()
    {
        return get_float_array(new float[4]);
    }
    
    public float[] get_float_array(float[] value)
    {
        assert(
            value != null
            && value.length == 4
        );
        int __nio__member_offset = 275;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.FloatBuffer tmpBuffer = __nio__buffer.asFloatBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public void set_float_array(float value, int index0)
    {
        int __nio__member_offset = 275;
        /* calc indexed offset */
        __nio__member_offset += (index0*4);
        __nio__buffer.putFloat(__nio__offset + __nio__member_offset, value);
    }
    
    public void set_float_array(float[] value)
    {
        assert(
            value != null
            && value.length == 4
        );
        int __nio__member_offset = 275;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.FloatBuffer tmpBuffer = __nio__buffer.asFloatBuffer();
        tmpBuffer.put(value);
    }
    
    public floatArrayView view_float_array()
    {
        floatArrayView view = floatArrayView.create(4);
        view.open(__nio__buffer, 0);
        return view_float_array(view);
    }
    
    public floatArrayView view_float_array(floatArrayView view)
    {
        int __nio__member_offset = __nio__offset + 275;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public double getDouble_array(int index0)
    {
        double result;
        int __nio__member_offset = 291;
        /* calc indexed offset */
        __nio__member_offset += (index0*8);
        result = __nio__buffer.getDouble(__nio__offset + __nio__member_offset);
        return result;
    }
    
    public double[] getDouble_array()
    {
        return getDouble_array(new double[5]);
    }
    
    public double[] getDouble_array(double[] value)
    {
        assert(
            value != null
            && value.length == 5
        );
        int __nio__member_offset = 291;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.DoubleBuffer tmpBuffer = __nio__buffer.asDoubleBuffer();
        tmpBuffer.get(value);
        return value;
    }
    
    public void setDouble_array(double value, int index0)
    {
        int __nio__member_offset = 291;
        /* calc indexed offset */
        __nio__member_offset += (index0*8);
        __nio__buffer.putDouble(__nio__offset + __nio__member_offset, value);
    }
    
    public void setDouble_array(double[] value)
    {
        assert(
            value != null
            && value.length == 5
        );
        int __nio__member_offset = 291;
        __nio__buffer.position(__nio__offset + __nio__member_offset);
        java.nio.DoubleBuffer tmpBuffer = __nio__buffer.asDoubleBuffer();
        tmpBuffer.put(value);
    }
    
    public doubleArrayView viewDouble_array()
    {
        doubleArrayView view = doubleArrayView.create(5);
        view.open(__nio__buffer, 0);
        return viewDouble_array(view);
    }
    
    public doubleArrayView viewDouble_array(doubleArrayView view)
    {
        int __nio__member_offset = __nio__offset + 291;
        view.offset(__nio__member_offset);
        return view;
    }
    
    @Override
    public MyArrayStructView clone()
    {
        return super.clone(new MyArrayStructView(this));
    }
    
    public MyArrayStructView clone(MyArrayStructView view)
    {
        return super.clone(view);
    }
    
    @Override
    public void close()
    {
        _byte_array_user.close();
        super.close();
    }
    
    @Override
    public Class<test.array.scalar.MyArrayStruct> javatype()
    {
        return test.array.scalar.MyArrayStruct.class;
    }
    
    @Override
    public test.array.scalar.MyArrayStruct newDataInstance()
    {
        test.array.scalar.MyArrayStruct result = new test.array.scalar.MyArrayStruct();
        result._byte_array = new byte[1];
        result._byte_array_user = new byte[8];
        result._short_array = new short[2];
        result._int_array_array = new int[2][8];
        result._long_array_array_array = new long[4][3][2];
        result._char_array = new char[3];
        result._float_array = new float[4];
        result.Double_array = new double[5];
        return result;
    }
    
    @Override
    public void offset(int offset)
    {
        super.offset(offset);
        _byte_array_user.offset(__nio__offset + 1);
    }
    
    @Override
    public void open(java.nio.ByteBuffer buffer, int offset)
    {
        super.open(buffer, offset);
        this._byte_array_user.open(buffer, __nio__offset + 1);
    }
    
    @Override
    public int sizeof()
    {
        return 331;
    }
    
}
