package org.cakelab.codegen;

import java.io.IOException;

public abstract class StaticInitBlock implements CodeGen {

	@Override
	public void write(IndentStreamControl pout) throws IOException {
		pout.println("static {");
		pout.indent(+1);
		writeBlockContent(pout);
		pout.indent(-1);
		pout.println("}");
	}

	protected abstract void writeBlockContent(IndentStreamControl pout);
	
}
