package org.cakelab.nio.generator.codegen;

import java.io.IOException;

import org.cakelab.codegen.ClassGen;
import org.cakelab.codegen.IndentStreamControl;
import org.cakelab.nio.meta.TypeMeta;

public class DefaultConstructorGen extends ViewClassConstructorGen {


	private TypeMeta type;

	public DefaultConstructorGen(ClassGen classgen, TypeMeta type) {
		super(classgen, "public", "", classgen.getClassName());
		this.type = type;
	}

	@Override
	public void writeMethodBody(IndentStreamControl pout) throws IOException {
		
		pout.println("super((short)" + type.align + ");");

	}
	

}
