package test.bool;

import org.cakelab.nio.view.GenericDataView;
import org.cakelab.nio.view.impl.StructViewBase;

public class IntBooleanView extends StructViewBase<Boolean> {

	
	public IntBooleanView(short alignment) {
		super(alignment);
	}
	
	@Override
	public int sizeof() {
		return Integer.BYTES;
	}

	@Override
	public Boolean get() {
		return Boolean.valueOf(__nio__buffer.getInt(__nio__offset) == 0 ? false : true);
	}

	@Override
	public void set(Boolean v) {
		set(v.booleanValue());
	}

	public void set(boolean v) {
		__nio__buffer.putInt(__nio__offset, v?1:0);
	}

	@Override
	public GenericDataView<Boolean> clone() {
		return super.clone(new IntBooleanView(this.alignment()));
	}

	@Override
	public Class<Boolean> javatype() {
		return Boolean.class;
	}

}
