package test.bool;

import org.cakelab.nio.view.impl.DataViewBase;
import org.cakelab.nio.view.scalar.booleanView;

public class shortBooleanView extends DataViewBase implements booleanView {

	public shortBooleanView(short alignment) {
		super(alignment);
	}

	public shortBooleanView(DataViewBase that) {
		super(that);
	}

	@Override
	public int sizeof() {
		return Short.BYTES;
	}

	@Override
	public Class<?> javatype() {
		return boolean.class;
	}

	@Override
	public boolean get() {
		return __nio__buffer.getShort(__nio__offset) != 0;
	}

	@Override
	public void set(boolean value) {
		__nio__buffer.putShort(__nio__offset, (short)(value?1:0));
	}

	@Override
	public booleanView clone() {
		return super.clone(new shortBooleanView(this));
	}

	@Override
	public booleanView clone(booleanView view) {
		return super.clone(view);
	}

}
