package test.strings;

import org.cakelab.nio.view.annotations.nio;

public class MyStringStruct {
	private static final int MAX_FILE_NAME_LENGTH = 128;
	private static final int MAX_PROPERTY_LENGTH = 16;
	
	@nio(length=MAX_FILE_NAME_LENGTH, view=AsciiStringView.class)
	public String ascii;
	
	@nio(length={4, MAX_PROPERTY_LENGTH}, view=AsciiStringView.class)
	public String[] asciiArray;
	
	@nio(length=4)
	public String standardString;
	
	@nio(length={2,4})
	public String[] standardStringArray;
	
}
