package test.strings;

import org.cakelab.nio.view.annotations.nio;

public class MyStringStructAligned {
	private static final int MAX_FILE_NAME_LENGTH = 128;
	private static final int MAX_PROPERTY_LENGTH = 16;
	
	@nio(align=2, length=MAX_FILE_NAME_LENGTH, view=AsciiStringView.class)
	public String ascii;
	
	@nio(align=4, length={4, MAX_PROPERTY_LENGTH}, view=AsciiStringView.class)
	public String[] asciiArray;
	
	@nio(align=2, length=4)
	public String standardString;
	
	@nio(align=1, length={2,4})
	public String[] standardStringArray;
	
	
	public byte alignmentTesting;
}
