package test.struct;

import org.cakelab.nio.view.annotations.nio;
import org.joml.Matrix4f;
import org.joml.Vector3f;
import org.joml.Vector4f;

public class MyStructStructAligned {
	public ReferencedClass reference;
	
	public static class EmbeddedStatic {
		@nio(length=3)
		public float[] rgb;
	}
	@nio(align=2)
	public EmbeddedStatic embedded;
	
	@nio(align=16)
	public static class ReferencedExternal {
		public Vector3f position;
		public Vector4f normal;
		
		@nio(view=Matrix4fView.class)
		public Matrix4f mv_matrix;
	} 
	public ReferencedExternal referencedExternal;
	
	public static class EmbeddedReference {
		public EmbeddedStatic reference;
	} 
	@nio(align=16)
	public EmbeddedReference embeddedReference;
	
	@nio(align=2)
	public static class DoubleEmbedded {
		public static class EmbeddedEmbedded {
			public int c;
		}
		public EmbeddedEmbedded embeddedEmbedded;
	} 
	public DoubleEmbedded doubleEmbedded;
	
	public byte alignmentTesting;
	
}
