package org.cakelab.nio.view.generated.test.strings;


import org.cakelab.nio.view.ReusableDataView;
import org.cakelab.nio.view.impl.StructViewBase;
import org.cakelab.nio.view.array.CArrayView;


/**
 * Generated view class for {@link test.strings.MyStringStruct}
 */
public class MyStringStructView extends StructViewBase<test.strings.MyStringStruct> implements ReusableDataView<test.strings.MyStringStruct> {
    static {
        /* If the following statement causes a compile error, the generated 
         * class is not compatible with the given version of org.cakelab.nio. */
        assert org.cakelab.nio.common.Global.VERSION_COMPATIBLE_1_0;
    }
    private test.strings.AsciiStringView ascii = new test.strings.AsciiStringView((short)1, 128);
    private test.strings.AsciiStringView asciiArray = new test.strings.AsciiStringView((short)1, 16);
    private org.cakelab.nio.view.string.StringView standardString = new org.cakelab.nio.view.string.StringView((short)1, 4);
    private org.cakelab.nio.view.string.StringView standardStringArray = new org.cakelab.nio.view.string.StringView((short)1, 4);
    
    public  MyStringStructView()
    {
        super((short)1);
    }
    
    public  MyStringStructView(MyStringStructView that)
    {
        super(that);
    }
    
    public  MyStringStructView(short alignment)
    {
        super(alignment);
    }
    
    public test.strings.MyStringStruct get()
    {
        return get(this.newDataInstance());
    }
    
    public test.strings.MyStringStruct get(test.strings.MyStringStruct result)
    {
        result.ascii = this.ascii.get();
        getAsciiArray(result.asciiArray);
        result.standardString = this.standardString.get();
        getStandardStringArray(result.standardStringArray);
        return result;
    }
    
    public void set(test.strings.MyStringStruct value)
    {
        this.ascii.set(value.ascii);
        setAsciiArray(value.asciiArray);
        this.standardString.set(value.standardString);
        setStandardStringArray(value.standardStringArray);
    }
    
    public java.lang.String getAscii()
    {
        return this.ascii.get();
    }
    
    public void setAscii(java.lang.String ascii)
    {
        this.ascii.set(ascii);
    }
    
    public test.strings.AsciiStringView viewAscii()
    {
        return this.ascii;
    }
    
    public test.strings.AsciiStringView viewAscii(test.strings.AsciiStringView result)
    {
        return this.ascii.clone(result);
    }
    
    public java.lang.String getAsciiArray(int index0)
    {
        java.lang.String result;
        int __nio__stride = 16;
        int __nio__elem__offset = __nio__offset + 128;
        __nio__elem__offset += (index0*16);
        this.asciiArray.offset(__nio__elem__offset);
        result = this.asciiArray.get();
        __nio__elem__offset += __nio__stride;
        return result;
    }
    
    public java.lang.String[] getAsciiArray()
    {
        return getAsciiArray(new java.lang.String[4]);
    }
    
    public java.lang.String[] getAsciiArray(java.lang.String[] value)
    {
        assert(
            value != null
            && value.length == 4
        );
        int __nio__stride = 16;
        int __nio__elem__offset = __nio__offset + 128;
        for (int index0 = 0; index0 < 4; index0++) {
            this.asciiArray.offset(__nio__elem__offset);
            value[index0] = this.asciiArray.get();
            __nio__elem__offset += __nio__stride;
        }
        return value;
    }
    
    public void setAsciiArray(java.lang.String value, int index0)
    {
        int __nio__stride = 16;
        int __nio__elem__offset = __nio__offset + 128;
        __nio__elem__offset += (index0*16);
        this.asciiArray.offset(__nio__elem__offset);
        this.asciiArray.set(value);
        __nio__elem__offset += __nio__stride;
    }
    
    public void setAsciiArray(java.lang.String[] value)
    {
        assert(
            value != null
            && value.length == 4
        );
        int __nio__stride = 16;
        int __nio__elem__offset = __nio__offset + 128;
        for (int index0 = 0; index0 < 4; index0++) {
            this.asciiArray.offset(__nio__elem__offset);
            this.asciiArray.set(value[index0]);
            __nio__elem__offset += __nio__stride;
        }
    }
    
    public CArrayView<java.lang.String,test.strings.AsciiStringView> viewAsciiArray()
    {
        CArrayView<java.lang.String,test.strings.AsciiStringView> view = new CArrayView<java.lang.String,test.strings.AsciiStringView>(new test.strings.AsciiStringView((short)1, 16), 4);
        view.open(__nio__buffer, 0);
        return viewAsciiArray(view);
    }
    
    public CArrayView<java.lang.String,test.strings.AsciiStringView> viewAsciiArray(CArrayView<java.lang.String,test.strings.AsciiStringView> view)
    {
        int __nio__member_offset = __nio__offset + 128;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public test.strings.AsciiStringView viewAsciiArray(int index0)
    {
        test.strings.AsciiStringView view = new test.strings.AsciiStringView((short)1, 16);
        view.open(__nio__buffer, 0);
        return viewAsciiArray(view, index0);
    }
    
    public test.strings.AsciiStringView viewAsciiArray(test.strings.AsciiStringView view, int index0)
    {
        int __nio__member_offset = __nio__offset + 128;
        /* calc indexed offset */
        __nio__member_offset += (index0*256);
        view.offset(__nio__member_offset);
        return view;
    }
    
    public java.lang.String getStandardString()
    {
        return this.standardString.get();
    }
    
    public void setStandardString(java.lang.String standardString)
    {
        this.standardString.set(standardString);
    }
    
    public org.cakelab.nio.view.string.StringView viewStandardString()
    {
        return this.standardString;
    }
    
    public org.cakelab.nio.view.string.StringView viewStandardString(org.cakelab.nio.view.string.StringView result)
    {
        return this.standardString.clone(result);
    }
    
    public java.lang.String getStandardStringArray(int index0)
    {
        java.lang.String result;
        int __nio__stride = 8;
        int __nio__elem__offset = __nio__offset + 200;
        __nio__elem__offset += (index0*8);
        this.standardStringArray.offset(__nio__elem__offset);
        result = this.standardStringArray.get();
        __nio__elem__offset += __nio__stride;
        return result;
    }
    
    public java.lang.String[] getStandardStringArray()
    {
        return getStandardStringArray(new java.lang.String[2]);
    }
    
    public java.lang.String[] getStandardStringArray(java.lang.String[] value)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__stride = 8;
        int __nio__elem__offset = __nio__offset + 200;
        for (int index0 = 0; index0 < 2; index0++) {
            this.standardStringArray.offset(__nio__elem__offset);
            value[index0] = this.standardStringArray.get();
            __nio__elem__offset += __nio__stride;
        }
        return value;
    }
    
    public void setStandardStringArray(java.lang.String value, int index0)
    {
        int __nio__stride = 8;
        int __nio__elem__offset = __nio__offset + 200;
        __nio__elem__offset += (index0*8);
        this.standardStringArray.offset(__nio__elem__offset);
        this.standardStringArray.set(value);
        __nio__elem__offset += __nio__stride;
    }
    
    public void setStandardStringArray(java.lang.String[] value)
    {
        assert(
            value != null
            && value.length == 2
        );
        int __nio__stride = 8;
        int __nio__elem__offset = __nio__offset + 200;
        for (int index0 = 0; index0 < 2; index0++) {
            this.standardStringArray.offset(__nio__elem__offset);
            this.standardStringArray.set(value[index0]);
            __nio__elem__offset += __nio__stride;
        }
    }
    
    public CArrayView<java.lang.String,org.cakelab.nio.view.string.StringView> viewStandardStringArray()
    {
        CArrayView<java.lang.String,org.cakelab.nio.view.string.StringView> view = new CArrayView<java.lang.String,org.cakelab.nio.view.string.StringView>(new org.cakelab.nio.view.string.StringView((short)1, 4), 2);
        view.open(__nio__buffer, 0);
        return viewStandardStringArray(view);
    }
    
    public CArrayView<java.lang.String,org.cakelab.nio.view.string.StringView> viewStandardStringArray(CArrayView<java.lang.String,org.cakelab.nio.view.string.StringView> view)
    {
        int __nio__member_offset = __nio__offset + 200;
        view.offset(__nio__member_offset);
        return view;
    }
    
    public org.cakelab.nio.view.string.StringView viewStandardStringArray(int index0)
    {
        org.cakelab.nio.view.string.StringView view = new org.cakelab.nio.view.string.StringView((short)1, 4);
        view.open(__nio__buffer, 0);
        return viewStandardStringArray(view, index0);
    }
    
    public org.cakelab.nio.view.string.StringView viewStandardStringArray(org.cakelab.nio.view.string.StringView view, int index0)
    {
        int __nio__member_offset = __nio__offset + 200;
        /* calc indexed offset */
        __nio__member_offset += (index0*32);
        view.offset(__nio__member_offset);
        return view;
    }
    
    @Override
    public MyStringStructView clone()
    {
        return super.clone(new MyStringStructView(this));
    }
    
    public MyStringStructView clone(MyStringStructView view)
    {
        return super.clone(view);
    }
    
    @Override
    public void close()
    {
        ascii.close();
        asciiArray.close();
        standardString.close();
        standardStringArray.close();
        super.close();
    }
    
    @Override
    public Class<test.strings.MyStringStruct> javatype()
    {
        return test.strings.MyStringStruct.class;
    }
    
    @Override
    public test.strings.MyStringStruct newDataInstance()
    {
        test.strings.MyStringStruct result = new test.strings.MyStringStruct();
        result.asciiArray = new java.lang.String[4];
        result.standardStringArray = new java.lang.String[2];
        return result;
    }
    
    @Override
    public void offset(int offset)
    {
        super.offset(offset);
        ascii.offset(__nio__offset + 0);
        asciiArray.offset(__nio__offset + 128);
        standardString.offset(__nio__offset + 192);
        standardStringArray.offset(__nio__offset + 200);
    }
    
    @Override
    public void open(java.nio.ByteBuffer buffer, int offset)
    {
        super.open(buffer, offset);
        this.ascii.open(buffer, __nio__offset + 0);
        this.asciiArray.open(buffer, __nio__offset + 128);
        this.standardString.open(buffer, __nio__offset + 192);
        this.standardStringArray.open(buffer, __nio__offset + 200);
    }
    
    @Override
    public int sizeof()
    {
        return 216;
    }
    
}
